import java.util.*;

class MCSbR extends MCSb {

    MCSbR (int n,boolean[][] A,int[] degree,int style) {
	super(n,A,degree,style);
    }

    void numberSort(ArrayList<Integer> C, ArrayList<Integer> ColOrd,ArrayList<Integer> P,int[] colour){
	int delta   = maxSize - C.size();
	int colours = 0;
	int m       = ColOrd.size();
	for (int i=0;i<m;i++) colourClass[i].clear();
	for (int i=0;i<m;i++){
	    int v = ColOrd.get(i);
	    int k = 0;
	    while (conflicts(v,colourClass[k])) k++;
	    colourClass[k].add(v);
	    colours = Math.max(colours,k+1);
	    if (k+1 > delta && colourClass[k].size() == 1 && repair(v,k)) colours--;
	}
	P.clear();
	int i = 0;
	for (int k=0;k<colours;k++)
	    //for (int j=0;j<colourClass[k].size();j++){
	    for (int j=colourClass[k].size()-1;j>=0;j--){
		int v = (Integer)(colourClass[k].get(j));
		P.add(v); 
		colour[i++] = k+1;
	    }
    }
}
