import java.util.*;
import java.io.*;

public class ReadDIMACSResults {

    private static int output(String resultsFname) throws IOException {
	Scanner sc    = new Scanner(new File(resultsFname));
	int size      = sc.nextInt();
	long nodes    = sc.nextLong();
	int ms        = sc.nextInt();
	sc.close();
	//System.out.print(nodes/1000);
	//System.out.print(ms/1000);
	System.out.print(nodes +" & "+ ms/1000 +" & ("+ size +")");
	return ms;
    }

    private static void stats(String fname) throws IOException {
	Scanner sc = new Scanner(new File(fname));
	while (sc.hasNext()){
	    String dimacsFname = sc.next();
	    System.out.print(dimacsFname + " & ");
	    //output("../DIMACS_results/MCQ1-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCQ2-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCQ3-" + dimacsFname);
	    //System.out.print(" & ");
	    int time1 = output("../DIMACS_results/MCSa1-" + dimacsFname);
	    System.out.print(" & ");
	    //output("../DIMACS_results/MCSa2-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCSa3-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCSb1-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCSb2-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/MCSb3-" + dimacsFname);
	    //System.out.print(" & ");
	    int time2 = output("../DIMACS_results/BBMC1-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/BBMC2-" + dimacsFname);
	    //System.out.print(" & ");
	    //output("../DIMACS_results/BBMC3-" + dimacsFname);
	    System.out.format(" & %.2f  ",((float)time1)/((float)time2));
	    System.out.println(" \\\\ \\hline");
	}
    }

    public static void main(String[] args) throws IOException {
	String files  = args[0];
	stats(files);
    }
}
//
// java ReadDIMACSResults dimacsFileNames > dimacsTable.tex
//
